

#include "crypto.h"
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
#include <string.h>


// Register Global File Descriptors //
int G_FD_INPUT = -1;
int G_FD_OUTPUT = -1;

FILE *G_FILE_INPUT = NULL;
FILE *G_FILE_OUTPUT = NULL;

int64_t *g_ptr_input_buffer_encrypt = NULL;
int64_t *g_ptr_output_buffer_encrypt = NULL;

int64_t *g_ptr_input_buffer_decrypt = NULL;
int64_t *g_ptr_output_buffer_decrypt = NULL;

int64_t g_key_bitwise_one = 0;

int g_bytes_read;

// Memory Counter //
int64_t g_counter_memory_encrypt_input_buffer = 0;
int64_t g_counter_memory_encrypt_output_buffer = 0;
int64_t g_counter_memory_decrypt_input_buffer = 0;
int64_t g_counter_memory_decrypt_output_buffer = 0;

int64_t g_counter_memory_int64_t = 0;
// Crypte keys Data Holder //
struct crypt_keys_caesar g_struct_crypt_keys_caesar;
struct crypt_keys_bitwise g_struct_crypt_keys_bitwise;

void set_crypt_keys_bitwise(crypt_keys_bitwise_t my_crypt_bitwise){
    g_struct_crypt_keys_bitwise = my_crypt_bitwise;
}
void set_crypt_keys_caesar(crypt_keys_caesar_t my_crypt_caesar){
    g_struct_crypt_keys_caesar = my_crypt_caesar;
}

// Memory Allocation Function //
void malloc_main_int64_t_array(int64_t **ptr_buffer,int size_memory){
    int64_t alloc_memory = sizeof(int64_t) * size_memory;
    (*ptr_buffer) = (int64_t * ) malloc(alloc_memory);
    if ( (*ptr_buffer) ){
         memset((*ptr_buffer),0,alloc_memory);
    }
}
// Memory Buffer Clear Function //
void crypto_clear_memory_encrypt(int64_t read_block){
	int64_t data_size = sizeof(int64_t) * read_block;
	memset(g_ptr_input_buffer_encrypt,0,data_size);
	memset(g_ptr_output_buffer_encrypt,0,data_size);

}
void crypto_clear_memory_decrypt(int64_t read_block){
	int64_t data_size = sizeof(int64_t) * read_block;
	memset(g_ptr_input_buffer_decrypt,0,data_size);
	memset(g_ptr_output_buffer_decrypt,0,data_size);
}
// Memory Free Funciton //
void crypto_free_memory_decrypt(void){
	if ( g_ptr_input_buffer_decrypt ) {
		free(g_ptr_input_buffer_decrypt);
		g_ptr_input_buffer_decrypt = NULL;
	}
	if ( g_ptr_output_buffer_decrypt ) {
		free(g_ptr_output_buffer_decrypt);
		g_ptr_output_buffer_decrypt = NULL;
	}
}
void crypto_free_memory_encrypt(void){
	if ( g_ptr_input_buffer_encrypt ) {
		free(g_ptr_input_buffer_encrypt);
		g_ptr_input_buffer_encrypt = NULL;
	}
	if ( g_ptr_output_buffer_encrypt ) {
		free(g_ptr_output_buffer_encrypt);
		g_ptr_output_buffer_encrypt = NULL;
	}
}


int lowlevel_open_file_read(char *ptr_file_name_input){
    int fd_input ; 
    fd_input = open(ptr_file_name_input,O_RDONLY);
    if ( fd_input < 0 ){
        printf("Error opening file.\n");
    }
    return fd_input;
}
int lowlevel_open_file_write(char *ptr_file_name_input){
    int fd_input ; 
    mode_t mode = S_IRUSR | S_IWUSR | S_IRGRP;
    fd_input = open(ptr_file_name_input,O_RDWR|O_CREAT|O_TRUNC, mode);
    if ( fd_input < 0 ){
        printf("Error opening file.\n");
    }
    return fd_input;
}
void pre_file_opener(char *ptr_in_fn,char *ptr_out_fn){
    G_FD_INPUT  = lowlevel_open_file_read(ptr_in_fn);
    G_FD_OUTPUT = lowlevel_open_file_write(ptr_out_fn);

}


int64_t encrypt_bitwise_with_key(int64_t original_data, int64_t bitwise_key){
    int64_t ret_bitwise_encrypted = 0;
    ret_bitwise_encrypted = original_data ^  bitwise_key;
    return ret_bitwise_encrypted;
}
int64_t decrypt_bitwise_with_key(int64_t raw_data,int64_t bitwise_key){
    int64_t ret_bitwise_decrypted = 0;
    ret_bitwise_decrypted = raw_data ^  bitwise_key;
    return ret_bitwise_decrypted;
}
int64_t encrypt_caesar_with_key(int64_t original_data,int64_t caesar_key){
    int64_t ret_caesar_encrypted = 0;
    ret_caesar_encrypted = original_data + caesar_key;
    return ret_caesar_encrypted;

}
int64_t decrypt_caesar_with_key(int64_t encrypted_data,int64_t caesar_key){
    int64_t ret_caesar_decrypted = 0;
    ret_caesar_decrypted = encrypted_data - caesar_key;
    return ret_caesar_decrypted;
}

void block_copy_encrypt(int64_t read_block,char *ptr_fn_in,char *ptr_fn_out){
   // FUNCTION CALL //
    pre_file_opener(ptr_fn_in,ptr_fn_out);

    int64_t retvalue_read_bytes = 0;
    // FOR Encryption temp Stored Data //
    int64_t enc_bitwise_one = 0;
    int64_t enc_bitwise_two = 0;
    int64_t enc_bitwise_three = 0;
    int64_t enc_bitwise_four = 0;
    int64_t enc_bitwise_five  = 0;
    int64_t enc_bitwise_six  = 0;
    int64_t enc_bitwise_seven  = 0;
    int64_t enc_bitwise_eight  = 0;
    // The Caesar's //
    int64_t enc_caesar_one = 0;
    int64_t enc_caesar_two = 0;
    int64_t enc_caesar_three = 0;
    int64_t enc_caesar_four = 0;
    int64_t enc_caesar_five = 0;
    int64_t enc_caesar_six = 0;
    int64_t enc_caesar_seven = 0;
    int64_t enc_caesar_eight = 0;


	malloc_main_int64_t_array(&g_ptr_input_buffer_encrypt,read_block);
	malloc_main_int64_t_array(&g_ptr_output_buffer_encrypt,read_block);
    while( (retvalue_read_bytes = read(G_FD_INPUT,g_ptr_input_buffer_encrypt,read_block)) >0){
        int64_t count_read_block = 0;
	for(count_read_block = 0; count_read_block < retvalue_read_bytes; count_read_block++){
		// First Caesar, With Key: ONE //
		enc_caesar_one   = encrypt_caesar_with_key(g_ptr_input_buffer_encrypt[count_read_block],g_struct_crypt_keys_caesar.crypt_key_caesar_one);
	        enc_bitwise_one  = encrypt_bitwise_with_key(enc_caesar_one,g_struct_crypt_keys_bitwise.crypt_key_bitwise_one);
		enc_caesar_two   = encrypt_caesar_with_key(enc_bitwise_one,g_struct_crypt_keys_caesar.crypt_key_caesar_two);
		enc_bitwise_two  = encrypt_bitwise_with_key(enc_caesar_two,g_struct_crypt_keys_bitwise.crypt_key_bitwise_two);

		enc_caesar_three   = encrypt_caesar_with_key(enc_bitwise_two,g_struct_crypt_keys_caesar.crypt_key_caesar_three);
		enc_bitwise_three  = encrypt_bitwise_with_key(enc_caesar_three,g_struct_crypt_keys_bitwise.crypt_key_bitwise_three);

		enc_caesar_four   = encrypt_caesar_with_key(enc_bitwise_three,g_struct_crypt_keys_caesar.crypt_key_caesar_four);
		enc_bitwise_four  = encrypt_bitwise_with_key(enc_caesar_four,g_struct_crypt_keys_bitwise.crypt_key_bitwise_four);
		// NEW //
		enc_caesar_five   = encrypt_caesar_with_key(enc_bitwise_four,g_struct_crypt_keys_caesar.crypt_key_caesar_five);
		enc_bitwise_five  = encrypt_bitwise_with_key(enc_caesar_five,g_struct_crypt_keys_bitwise.crypt_key_bitwise_five);

		enc_caesar_six   = encrypt_caesar_with_key(enc_bitwise_five,g_struct_crypt_keys_caesar.crypt_key_caesar_six);
		enc_bitwise_six  = encrypt_bitwise_with_key(enc_caesar_six,g_struct_crypt_keys_bitwise.crypt_key_bitwise_six);

		enc_caesar_seven   = encrypt_caesar_with_key(enc_bitwise_six,g_struct_crypt_keys_caesar.crypt_key_caesar_seven);
		enc_bitwise_seven  = encrypt_bitwise_with_key(enc_caesar_seven,g_struct_crypt_keys_bitwise.crypt_key_bitwise_seven);

		enc_caesar_eight   = encrypt_caesar_with_key(enc_bitwise_seven,g_struct_crypt_keys_caesar.crypt_key_caesar_eight);
		// Last Bitwise, With Key: eight //
		enc_bitwise_eight  = encrypt_bitwise_with_key(enc_caesar_eight,g_struct_crypt_keys_bitwise.crypt_key_bitwise_eight);

		g_ptr_output_buffer_encrypt[count_read_block] = enc_bitwise_eight;

	}
	// Write function need the read successfully readed //
	// byte to write out data //
	// write(..,..,retvalue_read); //
	//retvalue_write = write(G_FD_OUTPUT,g_ptr_output_buffer_encrypt,retvalue_read_bytes);
	write(G_FD_OUTPUT,g_ptr_output_buffer_encrypt,retvalue_read_bytes);
	//printf("ENCRYPT:WRITE VALUE: %ld\n",retvalue_write);
	crypto_clear_memory_encrypt(read_block);
    }
    crypto_free_memory_encrypt();
    close_files();
}
void block_copy_decrypt(int64_t read_block,char *ptr_fn_in,char *ptr_fn_out){
    // Function Call //
    pre_file_opener(ptr_fn_in,ptr_fn_out);
    // End function calls //
    int64_t retvalue_read_bytes = 0;

    malloc_main_int64_t_array(&g_ptr_input_buffer_decrypt,read_block);
    malloc_main_int64_t_array(&g_ptr_output_buffer_decrypt,read_block);
    // For decrypting temp variables 
    int64_t dec_caesar_one = 0;
    int64_t dec_caesar_two = 0;
    int64_t dec_caesar_three = 0;
    int64_t dec_caesar_four = 0;
    int64_t dec_caesar_five = 0;
    int64_t dec_caesar_six = 0;
    int64_t dec_caesar_seven = 0;
    int64_t dec_caesar_eight = 0;
    // Bitwise //
    int64_t dec_bitwise_one = 0;
    int64_t dec_bitwise_two = 0;
    int64_t dec_bitwise_three = 0;
    int64_t dec_bitwise_four = 0;
    int64_t dec_bitwise_five = 0;
    int64_t dec_bitwise_six = 0;
    int64_t dec_bitwise_seven = 0;
    int64_t dec_bitwise_eight = 0;

    while( (retvalue_read_bytes = read(G_FD_INPUT,g_ptr_input_buffer_decrypt,read_block)) >0){
	// First Last bitwise four //
	int64_t count_read_block = 0;
	for(count_read_block = 0; count_read_block < retvalue_read_bytes; count_read_block++){
		// First: the encrypt LAST:: 8.bitwise with key: Four ; 4.caesar  with key: Four// 
		// NEW Four keys //
		dec_bitwise_eight  = decrypt_bitwise_with_key(g_ptr_input_buffer_decrypt[count_read_block],g_struct_crypt_keys_bitwise.crypt_key_bitwise_eight); 
		dec_caesar_eight   = decrypt_caesar_with_key(dec_bitwise_eight,g_struct_crypt_keys_caesar.crypt_key_caesar_eight);

		dec_bitwise_seven  = decrypt_bitwise_with_key(dec_caesar_eight,g_struct_crypt_keys_bitwise.crypt_key_bitwise_seven); 
		dec_caesar_seven   = decrypt_caesar_with_key(dec_bitwise_seven,g_struct_crypt_keys_caesar.crypt_key_caesar_seven);

		dec_bitwise_six  = decrypt_bitwise_with_key(dec_caesar_seven,g_struct_crypt_keys_bitwise.crypt_key_bitwise_six); 
		dec_caesar_six   = decrypt_caesar_with_key(dec_bitwise_six,g_struct_crypt_keys_caesar.crypt_key_caesar_six);

		dec_bitwise_five  = decrypt_bitwise_with_key(dec_caesar_six,g_struct_crypt_keys_bitwise.crypt_key_bitwise_five); 
		dec_caesar_five   = decrypt_caesar_with_key(dec_bitwise_five,g_struct_crypt_keys_caesar.crypt_key_caesar_five);

		// OLD Block //
		dec_bitwise_four  = decrypt_bitwise_with_key(dec_caesar_five,g_struct_crypt_keys_bitwise.crypt_key_bitwise_four); 
		dec_caesar_four   = decrypt_caesar_with_key(dec_bitwise_four,g_struct_crypt_keys_caesar.crypt_key_caesar_four);
		// The third keys //
		dec_bitwise_three = decrypt_bitwise_with_key(dec_caesar_four,g_struct_crypt_keys_bitwise.crypt_key_bitwise_three);
		dec_caesar_three  = decrypt_caesar_with_key(dec_bitwise_three,g_struct_crypt_keys_caesar.crypt_key_caesar_three);
		// The second keys //
		dec_bitwise_two = decrypt_bitwise_with_key(dec_caesar_three,g_struct_crypt_keys_bitwise.crypt_key_bitwise_two);
		dec_caesar_two  = decrypt_caesar_with_key(dec_bitwise_two,g_struct_crypt_keys_caesar.crypt_key_caesar_two);
		// The First keys //	
		dec_bitwise_one = decrypt_bitwise_with_key(dec_caesar_two,g_struct_crypt_keys_bitwise.crypt_key_bitwise_one);
		dec_caesar_one  = decrypt_caesar_with_key(dec_bitwise_one,g_struct_crypt_keys_caesar.crypt_key_caesar_one);


		// Put The decrypted data to output buffer //
		g_ptr_output_buffer_decrypt[count_read_block] = dec_caesar_one;
	}
        // Write function need the read successfully readed //
        // byte to write out data //
        // write(..,..,retvalue_read); //
        //retvalue_write_bytes = write(g_fd_output,g_ptr_output_buffer_decrypt,retvalue_read_bytes);
        write(G_FD_OUTPUT,g_ptr_output_buffer_decrypt,retvalue_read_bytes);
        //printf("decrypt: Write value: %ld\n",retvalue_write_bytes);
	crypto_clear_memory_decrypt(read_block);
    }
    crypto_free_memory_decrypt();
    close_files();
}

void close_files(void){
    if ( G_FD_INPUT){
        close(G_FD_INPUT);
    }
    if ( G_FD_OUTPUT ){
        close(G_FD_OUTPUT);
    }
}
