/*
* This is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

typedef struct crypt_keys_bitwise {
    int64_t crypt_key_bitwise_one;
    int64_t crypt_key_bitwise_two;
    int64_t crypt_key_bitwise_three;
    int64_t crypt_key_bitwise_four;
    int64_t crypt_key_bitwise_five;
    int64_t crypt_key_bitwise_six;
    int64_t crypt_key_bitwise_seven;
    int64_t crypt_key_bitwise_eight;
} crypt_keys_bitwise_t;

typedef struct crypt_keys_caesar {
    int64_t crypt_key_caesar_one;
    int64_t crypt_key_caesar_two;
    int64_t crypt_key_caesar_three;
    int64_t crypt_key_caesar_four;
    int64_t crypt_key_caesar_five;
    int64_t crypt_key_caesar_six;
    int64_t crypt_key_caesar_seven;
    int64_t crypt_key_caesar_eight;
} crypt_keys_caesar_t;


FILE *file_open_read(char *ptr_file_name);
FILE *file_open_write(char *ptr_file_name);

void malloc_main_int64_t_array(int64_t **ptr_buffer,int size_memory);

void set_crypt_keys_bitwise(crypt_keys_bitwise_t my_bitwise_key);
void set_crypt_keys_caesar(crypt_keys_caesar_t my_caesar_key);

int64_t encrypt_bitwise_with_key(int64_t original_data,int64_t key_bitwise);
int64_t decrypt_bitwise_with_key(int64_t encrypted_data, int64_t key_bitwise);

int64_t encrypt_caesar_with_key(int64_t original_data,int64_t key_caesar);
int64_t decrypt_caesar_with_key(int64_t encrypted_data,int64_t key_caesar);

void pre_file_opener(char *ptr_in,char *ptr_out);


void block_copy_encrypt(int64_t read_block,char *ptr_fn_in, char *ptr_fn_out);
void block_copy_decrypt(int64_t read_block,char *ptr_fn_in, char *ptr_fn_out);



void crypto_clear_memory_encrypt(int64_t read_block);
void crypto_clear_memory_decrypt(int64_t read_block);
void crypto_free_memory_decrypt(void);
void crypto_free_memory_encrypt(void);

void close_files(void);
